H - Legal or Not HDU - 3342 【拓扑排序】

ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.

Input

The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0. 
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.

Output

For each test case, print in one line the judgement of the messy relationship. 
If it is legal, output "YES", otherwise "NO".

Sample Input

3 2
0 1
1 2
2 2
0 1
1 0
0 0

Sample Output

YES
NO
拓扑排序判断是否所有点入度为零即可
#include<iostream>
#include<cstring>
#define ms(a) memset(a,0,sizeof(a))
using namespace std;
const int maxn=1e3+10;
int n,m;
int a[maxn][maxn];//a记录两点是否相连
int in[maxn];//in记录点的入度
int toposort(){
	int cnt=0; 
    for(int i=1;i<=n;i++){//n 个数 
        for(int j=0;j<n;j++){
            if(in[j]==0){//如果入度为0(没有前驱点)
                in[j]=-1;//入度变成-1进行标记(入度为-1的点均为已经删除的点)删除节点 
                cnt++;//记录入度为零点的个数
				for(int k=0;k<n;k++){
                    if(a[j][k]) in[k]--;//将与j相连的节点都删去(删除与j有关的边) 删除点 
                }
                break;
            }
        }
    }
    return cnt;
}
int main(){
    std::ios::sync_with_stdio(false);
    int x,y;
    while(cin>>n>>m,n||m) {
        ms(a);
        ms(in);
        for(int i=1;i<=m;i++){//m 行数据 
            cin>>x>>y;
            if(!a[x][y]){//不加不过 防止加入多个相同的点
                a[x][y]=1;
                in[y]++;//记录入度 
            }
        }
        if(toposort()==n) cout<<"YES"<<endl;
		else cout<<"NO"<<endl;
    }
}
#include<iostream>
#include<cstring>
#define ms(a) memset(a,0,sizeof(a))
using namespace std;
const int maxn=1e3+10;
int n,m;
int a[maxn][maxn];//a记录两点是否相连
int in[maxn];//in记录点的入度
void toposort(){
	int cnt=0; 
    for(int i=1;i<=n;i++){//n 个数 
        for(int j=0;j<n;j++){
            if(in[j]==0){//如果入度为0(没有前驱点)
                in[j]=-1;//入度变成-1进行标记(入度为-1的点均为已经删除的点)删除节点 
				for(int k=0;k<n;k++){
                    if(a[j][k]) in[k]--;//将与j相连的节点都删去(删除与j有关的边) 删除点 
                }
                break;
            }
        }
    }
}
int main(){
    std::ios::sync_with_stdio(false);
    int x,y;
    while(cin>>n>>m,n||m) {
        ms(a);
        ms(in);
        for(int i=1;i<=m;i++){//m 行数据 
            cin>>x>>y;
            if(!a[x][y]){//不加不过 防止加入多个相同的点
                a[x][y]=1;
                in[y]++;//记录入度 
            }
        }
        toposort();
        int flag=0;
        for(int i=0;i<n;i++){
        	if(in[i]!=-1){//入度-1为 标记 
        		flag=1;break;
			}
		} 
		if(flag) cout<<"NO"<<endl;
		else cout<<"YES"<<endl;
    }
}

猜你喜欢

转载自blog.csdn.net/qq_41333844/article/details/81428454
今日推荐